OGRE-Next: Ogre::TagPoint Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Ogre::TagPoint Class Reference
Core » Animation

TagPoints are like SceneNodes, that can be children of a Bone. More...

`#include <OgreTagPoint.h>`

Inheritance diagram for Ogre::TagPoint:
[legend]

## Public Member Functions
| TagPoint (IdType id, SceneManager *creator, NodeMemoryManager *nodeMemoryManager, SceneNode *parent)
| ~TagPoint () override
Matrix3 | _getDerivedOrientationMatrix () const
void | _setParentBone (Bone *bone)
| Don't call directly.
void | _unsetParentBone ()
virtual TagPoint * | createChildTagPoint (const Vector3 &vPos=Vector3::ZERO, const Quaternion &qRot=Quaternion::IDENTITY)
Bone * | getParentBone () const
| Gets this Bones's parent (NULL if no parent).
Public Member Functions inherited from Ogre::SceneNode
| SceneNode (const Transform &transformPtrs)
| Don't use this constructor unless you know what you're doing.
| SceneNode (IdType id, SceneManager *creator, NodeMemoryManager *nodeMemoryManager, SceneNode *parent)
| Constructor, only to be called by the creator SceneManager.
| ~SceneNode () override
virtual_l1 void | _attachBone (SkeletonInstance *skeletonInstance, Bone *bone)
| Attaches a bone to this SceneNode.
void | _callMemoryChangeListeners () override
| Internal use, notifies all attached objects that our memory pointers (i.e.
virtual_l1 void | _detachAllBones (SkeletonInstance *skeletonInstance)
| Detaches all bones from this SceneNode that belong to the given SkeletonInstance.
virtual_l1 void | _detachBone (SkeletonInstance *skeletonInstance, Bone *bone)
| Detaches a bone from this SceneNode.
void | _notifyStaticDirty () const override
| Called by SceneManager when it is telling we're a static node being dirty Don't call this directly.
void | _setCachedTransformOutOfDate () override
virtual_l2 void | attachObject (MovableObject *obj)
| Adds an instance of a scene object to this node.
virtual SceneNode * | createChildSceneNode (SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new SceneNode as a child of this node.
virtual void | detachAllBones ()
| Detaches all bones from from this SceneNode. It is safe to use directly.
virtual void | detachAllObjects ()
| Detaches all objects attached to this node.
virtual_l2 void | detachObject (MovableObject *obj)
| Detaches an object by pointer.
virtual void | flipVisibility (bool cascade=true)
| Inverts the visibility of all objects attached to this node.
MovableObject * | getAttachedObject (const String &name)
| Retrieves a pointer to an attached object.
MovableObject * | getAttachedObject (size_t index)
| Retrieves a pointer to an attached object.
virtual ObjectIterator | getAttachedObjectIterator ()
| Retrieves an iterator which can be used to efficiently step through the objects attached to this node.
virtual ConstObjectIterator | getAttachedObjectIterator () const
| Retrieves an iterator which can be used to efficiently step through the objects attached to this node.
const ObjectVec & | getAttachments ()
SceneManager * | getCreator () const
| Gets the creator of this scene node.
NodeMemoryManager * | getDefaultNodeMemoryManager (SceneMemoryMgrTypes sceneType) override
| As Node::getDebugRenderable, except scaling is automatically determined.
SceneNode * | getParentSceneNode () const
| Gets the parent of this SceneNode.
bool | isYawFixed () const
virtual void | lookAt (const Vector3 &targetPoint, TransformSpace relativeTo, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Points the local -Z direction of this node at a point in space.
size_t | numAttachedObjects () const
| Reports the number of objects attached to this node.
virtual void | removeAndDestroyAllChildren ()
| Removes and destroys all children of this node.
virtual void | removeAndDestroyChild (SceneNode *sceneNode)
| This method removes and destroys the child and all of its children.
virtual void | setAutoTracking (bool enabled, SceneNode *const target=0, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of another SceneNode.
virtual void | setDirection (const Vector3 &vec, TransformSpace relativeTo=TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Sets the node's direction vector ie it's local -z.
virtual void | setDirection (Real x, Real y, Real z, TransformSpace relativeTo=TS_LOCAL, const Vector3 &localDirectionVector=Vector3::NEGATIVE_UNIT_Z)
| Sets the node's direction vector ie it's local -z.
void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the node whether to yaw around it's own local Y axis or a fixed axis of choice.
void | setListener (Listener *listener) override
| Sets a listener for this Node.
bool | setStatic (bool bStatic) override
| Turns this Node into static or dynamic.
virtual void | setVisible (bool visible, bool cascade=true)
| Makes all objects attached to this node become visible / invisible.
void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Y-axis.
Public Member Functions inherited from Ogre::Node
| Node (const Transform &transformPtrs)
| Don't use this constructor unless you know what you're doing.
| Node (IdType id, NodeMemoryManager *nodeMemoryManager, Node *parent)
| Constructor, should only be called by parent, not directly.
virtual | ~Node ()
virtual_l2 Quaternion | _getDerivedOrientation () const
| Gets the orientation of the node as derived from all parents.
virtual_l2 Quaternion | _getDerivedOrientationUpdated ()
| Gets the orientation of the node as derived from all parents.
virtual_l2 Vector3 | _getDerivedPosition () const
| Gets the position of the node as derived from all parents.
virtual_l2 Vector3 | _getDerivedPositionUpdated ()
| Gets the position of the node as derived from all parents.
virtual_l2 Vector3 | _getDerivedScale () const
| Gets the scaling factor of the node as derived from all parents.
virtual_l2 Vector3 | _getDerivedScaleUpdated ()
| Gets the scalling factor of the node as derived from all parents.
virtual_l2 FORCEINLINE const Matrix4 & | _getFullTransform () const
| Gets the full transformation matrix for this node.
virtual_l2 const Matrix4 & | _getFullTransformUpdated ()
| See _getDerivedScaleUpdated() remarks.
Transform & | _getTransform ()
| Returns a direct access to the Transform state.
virtual_l2 void | _setDerivedOrientation (const Quaternion &q)
| Sets the final world orientation of the node directly.
virtual_l2 void | _setDerivedPosition (const Vector3 &pos)
| Sets the final world position of the node directly.
void | _setNullNodeMemoryManager ()
| Manually set the mNodeMemoryManager to a null ptr.
void | _updateChildren ()
| Helper method to update the Node and all children.
void | addChild (Node *child)
| Adds a (precreated) child scene node to this node.
virtual_l2 Vector3 | convertLocalToWorldDirection (const Vector3 &localDir, bool useScale)
| Gets the world direction of a point in the node local space useful for simple transforms that don't require a child node.
Vector3 | convertLocalToWorldDirectionUpdated (const Vector3 &localDir, bool useScale)
virtual_l2 Quaternion | convertLocalToWorldOrientation (const Quaternion &localOrientation)
| Gets the world orientation of an orientation in the node local space useful for simple transforms that don't require a child node.
Quaternion | convertLocalToWorldOrientationUpdated (const Quaternion &localOrientation)
virtual_l2 Vector3 | convertLocalToWorldPosition (const Vector3 &localPos)
| Gets the world position of a point in the node local space useful for simple transforms that don't require a child node.
Vector3 | convertLocalToWorldPositionUpdated (const Vector3 &localPos)
virtual_l2 Vector3 | convertWorldToLocalDirection (const Vector3 &worldDir, bool useScale)
| Gets the local direction, relative to this node, of the given world-space direction.
Vector3 | convertWorldToLocalDirectionUpdated (const Vector3 &worldDir, bool useScale)
virtual_l2 Quaternion | convertWorldToLocalOrientation (const Quaternion &worldOrientation)
| Gets the local orientation, relative to this node, of the given world-space orientation.
Quaternion | convertWorldToLocalOrientationUpdated (const Quaternion &worldOrientation)
virtual_l2 Vector3 | convertWorldToLocalPosition (const Vector3 &worldPos)
| Gets the local position, relative to this node, of the given world-space position.
Vector3 | convertWorldToLocalPositionUpdated (const Vector3 &worldPos)
virtual Node * | createChild (SceneMemoryMgrTypes sceneType=SCENE_DYNAMIC, const Vector3 &translate=Vector3::ZERO, const Quaternion &rotate=Quaternion::IDENTITY)
| Creates an unnamed new Node as a child of this node.
Node * | getChild (size_t index)
| Gets a pointer to a child node.
const Node * | getChild (size_t index) const
NodeVecIterator | getChildIterator ()
| Retrieves an iterator for efficiently looping through all children of this node.
ConstNodeVecIterator | getChildIterator () const
| Retrieves an iterator for efficiently looping through all children of this node.
uint16 | getDepthLevel () const
| Returns how deep in the hierarchy we are (eg. 0 -> root node, 1 -> child of root)
bool | getIndestructibleByClearScene () const
virtual_l2 bool | getInheritOrientation () const
| Returns true if this node is affected by orientation applied to the parent node.
virtual_l2 bool | getInheritScale () const
| Returns true if this node is affected by scaling factors applied to the parent node.
Listener * | getListener () const
| Gets the current listener for this Node.
virtual_l2 Matrix3 | getLocalAxes () const
| Gets a matrix whose columns are the local axes based on the nodes orientation relative to it's parent.
const String & | getName () const
| Returns the name of the node.
virtual_l2 Quaternion | getOrientation () const
| Returns a quaternion representing the nodes orientation.
Node * | getParent () const
| Gets this node's parent (NULL if this is the root).
virtual_l2 Vector3 | getPosition () const
| Gets the position of the node relative to it's parent.
virtual_l2 Vector3 | getScale () const
| Gets the scaling factor of this node.
virtual Real | getSquaredViewDepth (const Camera *cam) const
| Helper function, get the squared view depth.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
bool | isCachedTransformOutOfDate () const
bool | isStatic () const
| Checks whether this node is static.
void | migrateTo (NodeMemoryManager *nodeMemoryManager)
| Migrates the node and all of its children to the new memory manager, at the same depth level.
size_t | numChildren () const
| Reports the number of child nodes under this one.
virtual_l2 void | pitch (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the X-axis.
virtual void | removeAllChildren ()
| Removes all child Nodes attached to this node.
virtual void | removeChild (Node *child)
| Drops the specified child from this node.
virtual_l1 void | resetOrientation ()
| Resets the nodes orientation (local axes as world axes, no rotation).
virtual_l2 void | roll (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Z-axis.
virtual_l2 void | rotate (const Quaternion &q, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis using a Quarternion.
virtual_l2 void | rotate (const Vector3 &axis, const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around an arbitrary axis.
virtual_l2 void | scale (const Vector3 &scale)
| Scales the node, combining it's current scale with the passed in scaling factor.
virtual_l2 void | scale (Real x, Real y, Real z)
| Scales the node, combining it's current scale with the passed in scaling factor.
void | setIndestructibleByClearScene (bool indestructible)
| Calling SceneManager::clearScene won't destroy this node nor detach its objects (but may still destroy parent and children nodes if they're not indestructible) when this is true.
virtual_l2 void | setInheritOrientation (bool inherit)
| Tells the node whether it should inherit orientation from it's parent node.
virtual_l2 void | setInheritScale (bool inherit)
| Tells the node whether it should inherit scaling factors from it's parent node.
void | setName (const String &name)
| Sets a custom name for this node.
virtual_l1 void | setOrientation (Quaternion q)
| Sets the orientation of this node via a quaternion.
virtual_l1 void | setOrientation (Real w, Real x, Real y, Real z)
| Sets the orientation of this node via quaternion parameters.
virtual_l1 void | setPosition (const Vector3 &pos)
| Sets the position of the node relative to it's parent.
virtual_l1 void | setPosition (Real x, Real y, Real z)
| Sets the position of the node relative to it's parent.
virtual_l1 void | setScale (const Vector3 &scale)
| Sets the scaling factor applied to this node.
virtual_l1 void | setScale (Real x, Real y, Real z)
| Sets the scaling factor applied to this node.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)
virtual_l2 void | translate (const Matrix3 &axes, const Vector3 &move, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
virtual_l2 void | translate (const Matrix3 &axes, Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the node along arbitrary axes.
virtual_l2 void | translate (const Vector3 &d, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the Cartesian axes.
virtual_l2 void | translate (Real x, Real y, Real z, TransformSpace relativeTo=TS_PARENT)
| Moves the node along the Cartesian axes.
virtual_l2 void | yaw (const Radian &angle, TransformSpace relativeTo=TS_LOCAL)
| Rotate the node around the Y-axis.
Public Member Functions inherited from Ogre::IdObject
| IdObject (IdType id)
| We don't call generateNewId() here, to prevent objects in the stack (i.e.
IdType | getId () const
| Get the unique id of this object.
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)

## Static Public Member Functions
static void | updateAllTransformsBoneToTag (const size_t numNodes, Transform t)
| See Node::updateAllTransforms.
static void | updateAllTransformsTagOnTag (const size_t numNodes, Transform t)
| See Node::updateAllTransforms.
Static Public Member Functions inherited from Ogre::Node
static void | updateAllTransforms (const size_t numNodes, Transform t)

## Additional Inherited Members
Public Types inherited from Ogre::SceneNode
typedef ConstVectorIterator< ObjectVec > | ConstObjectIterator
typedef VectorIterator< ObjectVec > | ObjectIterator
typedef vector< MovableObject * >::type | ObjectVec
Public Types inherited from Ogre::Node
typedef ConstVectorIterator< NodeVec > | ConstNodeVecIterator
typedef vector< Node * >::type | NodeVec
typedef VectorIterator< NodeVec > | NodeVecIterator
enum | TransformSpace { TS_LOCAL , TS_PARENT , TS_WORLD }
| Enumeration denoting the spaces which a transform can be relative to. More...
Public Attributes inherited from Ogre::Node
size_t | mGlobalIndex
| Index in the vector holding this node reference (could be our parent node, or a global array tracking all created nodes to avoid memory leaks).
size_t | mParentIndex
| Index in the vector holding this node reference (could be our parent node, or a global array tracking all created nodes to avoid memory leaks).

## Detailed Description

TagPoints are like SceneNodes, that can be children of a Bone.

Q: Can I use a SceneNode as child of a Bone? A: No.

Q: Can I use a TagPoint as child of a Bone? A: Yes. That's the idea.

Q: Can I use a SceneNode as child of a TagPoint? A: Yes.

Q: Can I use a TagPoint as child of a TagPoint? A: Yes.

Q: Can I use a TagPoint as child of a SceneNode? A: Yes.

Q: Is there a performance hit for using a TagPoint as a SceneNode? A: No, though there is higher memory consumption (and indirectly could decrease performance by affecting the cache or the bandwidth)

Q: So... TagPoints are better than SceneNodes, because they can be used like SceneNodes, but also be used with bones? A: Yes.

Q: Why not merge TagPoints into SceneNodes then, and remove TagPoints? A: Good question. Theoretically the TagPoint functionality does not belong to SceneNode (more dependencies, more clutter in the same cpp files). Also TagPoints require more memory; which can add up when you have tens of thousands (or +100k's) of nodes. Only pay for what you use.

Q: Can I attach a TagPoint to Skeleton 'A' bone, and then attach an Item/Entity with Skeleton 'B' to this TagPoint? A: Yesish. It will work, but Skeleton B will see the changes from Skeleton A with one frame of latency (i.e. lag behind). If the animation is too fast or too different between frames, it may be noticeable. That's because we update Skeleton A, then B, then the TagPoints. To fix this we would have to update Skeleton 'A', then the TagPoints, then Skeleton 'B'; which is too cumbersome for such rare corner case.

Q: What happens on circular dependencies? i.e. Skeleton gets attached to TagPoint, TagPoint gets attached to bone of said Skeleton? A: Undefined. Probably very wonky behavior.

Q: What happens if I call setStatic( true )? A: If the TagPoint is ultimately the child of a Bone, then nothing happens. If the TagPoint is ultimately the child of the Root SceneNode, then it works as usual.

Q: What happens if I called setStatic( true ) on a TagPoint that belonged to the Root SceneNode, and now I've detached, and attached it to a bone? A: The information about being static is completely lost (i.e. it's like calling setStatic( false ) prior to attaching to the bone)

## Constructor & Destructor Documentation

## ◆ TagPoint()

Ogre::TagPoint::TagPoint | ( | IdType | id,
|  | SceneManager * | creator,
|  | NodeMemoryManager * | nodeMemoryManager,
|  | SceneNode * | parent )

References Ogre::SceneNode::SceneNode().

Referenced by createChildTagPoint().

## ◆ ~TagPoint()

Ogre::TagPoint::~TagPoint | ( |  | ) |
| override

## Member Function Documentation

## ◆ _getDerivedOrientationMatrix()

Matrix3 Ogre::TagPoint::_getDerivedOrientationMatrix | ( |  | ) | const

## ◆ _setParentBone()

void Ogre::TagPoint::_setParentBone | ( | Bone * | bone | ) |

Don't call directly.

See also
  Bone::addTagPoint

## ◆ _unsetParentBone()

void Ogre::TagPoint::_unsetParentBone | ( |  | ) |

## ◆ createChildTagPoint()

virtual TagPoint * Ogre::TagPoint::createChildTagPoint | ( | const Vector3 & | vPos = Vector3::ZERO,
|  | const Quaternion & | qRot = Quaternion::IDENTITY )
| virtual

References TagPoint(), Ogre::Quaternion::IDENTITY, and Ogre::Vector3::ZERO.

## ◆ getParentBone()

Bone * Ogre::TagPoint::getParentBone | ( |  | ) | const
| inline

Gets this Bones's parent (NULL if no parent).

## ◆ updateAllTransformsBoneToTag()

static void Ogre::TagPoint::updateAllTransformsBoneToTag | ( | const size_t | numNodes,
|  | Transform | t )
| static

See Node::updateAllTransforms.

This version grabs the parent Bone of a TagPoint, derives the final transform in world space (supporting non-uniform scaling), and decomposes the matrix into derived position/quaternion/scale (the quaternion and scale aren't very useful if the skeleton is actually using non-uniform scaling though)

## ◆ updateAllTransformsTagOnTag()

static void Ogre::TagPoint::updateAllTransformsTagOnTag | ( | const size_t | numNodes,
|  | Transform | t )
| static

See Node::updateAllTransforms.

This version grabs the parent of a TagPoint, and derives the final transform of another TagPoint, respecting non-uniform scaling.

The documentation for this class was generated from the following file:

- Animation/OgreTagPoint.h